#ifndef BUFFER_H
#define BUFFER_H

#include "glew.h"
#include <vector>

template <typename T>
class Buffer
{
public:
   enum BufferType
   {
      VBO,
      EBO,
      UBO
   };

   class BufferEditor
   {
         GLenum m_typeEnum;
         T *ptr;
         
      public:
         BufferEditor(Buffer *b);
         ~BufferEditor();
         
         T* getPointer();
   };
   
    Buffer(const std::vector<T> &data, BufferType type, bool isDynamic = false);
    ~Buffer();
    
    void setVertexAttrib(int location, int nbComponents, int offset = 0, int instanceDivisor = 0);
    
    GLuint getId() {return m_id;}
    BufferType getType() {return m_type;}
    bool isDynamic() {return m_isDynamic;}
    
private:
    GLuint m_id;
    BufferType m_type;
    bool m_isDynamic;
    
    GLenum getGLEnum(BufferType type);
};

#endif // BUFFER_H
