#ifndef MATERIAL_H
#define MATERIAL_H

class Shader;

class Material
{
public:
    /**
     * @brief bindAttributes should send the material attribute to the specified shader as a uniform
     * if the shader is NULL, we can assume that modern opengl is not available and try to apply the material differently (glMaterial)
     */
    virtual void bindAttributes(Shader*) = 0;

    virtual unsigned int getFlags() = 0;

    virtual ~Material(){}
};

#endif // MATERIAL_H
