#include "scene.h"
#include "mesh.h"
#include <set>

std::vector<unsigned int> getMeshTypes()
{
    std::set<unsigned int> typesSet;
    std::vector<unsigned int> types;
    for(SceneIterator<GeometryNode*>* geometryIt = scene->getGeometry();
        geometryIt->isValid(); geometryIt->next())
    {
        typesSet.emplace(geometryIt->getItem()->mesh->getFlags());
    }
    for(unsigned int type : typesSet)
        types.push_back(type);
    return types;
}
